function trans_opt
format long

load lambda lambda
load n0 n0
load n1 n1
load X X
load Y Y
load MX MX
load MY MY

%%

CX				= cumsum(MX) ;
CY				= cumsum(MY) ;

Lm	 			= 10 ;
Lp				= 10 ;
L				= max(Lp,Lm) ;
	
epsi				= 1e-15 ;
	
tm				= -1 ;
tp				=  1 ;
tc				= .5*(tm+tp) ;	
	
pasfini				= 1 ;

test				= 0 ;



%%

if test
Ctest1				=  C(0  ,X,Y,CX,CY,n0,n1,lambda) ;
Ctest2				=  C(0.2,X,Y,CX,CY,n0,n1,lambda) ;
s				= rand() ;
tau				= 1e-4 ;
[Dd,Dd]		 		= dC(s,X,Y,CX,CY,n0,n1,lambda) 
Ddapprox			= (C(s+tau,X,Y,CX,CY,n0,n1,lambda) - C(s    ,X,Y,CX,CY,n0,n1,lambda)) / tau
Dgapprox			= (C(s    ,X,Y,CX,CY,n0,n1,lambda) - C(s-tau,X,Y,CX,CY,n0,n1,lambda)) / tau
end
%%

iter				= 0 ;
fprintf(2,'iteration 0 | tm = %f | tp = %f | tc = %f | cout = %f\n',tm,tp,tc,C(tc,X,Y,CX,CY,n0,n1,lambda))

%%
while pasfini
	iter			= iter + 1 ;
	[dCp,dCm]		= dC(tc,X,Y,CX,CY,n0,n1,lambda) ; 
	pasfini			= (dCp*dCm)>0 ;
    
    
	if ((tp-tm)<epsi/L)*pasfini
	fprintf('\n ***** tp-tm petit ***** \n ')
		[dCptp,dCmtp]	= dC(tp,X,Y,CX,CY,n0,n1,lambda) 
		[dCptm,dCmtm]	= dC(tm,X,Y,CX,CY,n0,n1,lambda) 
		Ctp		=  C(tp,X,Y,CX,CY,n0,n1,lambda) 
		Ctm		=  C(tm,X,Y,CX,CY,n0,n1,lambda) 
		if abs(dCptm-dCmtp)>0.001
			tc	= (Ctp-Ctm + dCptm*tm - dCmtp*tp)/(dCptm-dCmtp) 
		end
		pasfini		= 0 ;
  
    elseif (pasfini>0)
		if dCp<0	
			tm	= tc ;
		else
			tp	= tc ;
		end	
		tc		= .5*(tm+tp) ;
   else
        tc      = tc;
	end
	fprintf(2,'iteration %i | tm = %f | tp = %f | tc = %f | dCp = %f | dCm =%f | cout = %f\n',iter,tm,tp,tc,dCp,dCm,C(tc,X,Y,CX,CY,n0,n1,lambda))
end
%%
cout=C(tc,X,Y,CX,CY,n0,n1,lambda)
tc
end
%------------------------------------------
function valC = C(t,X,Y,CX,CY,n0,n1,lambda)
%%
Ip				= CY-(t-floor(t))>=0 ;
In				= CY-(t-floor(t))< 0 ;

valF0				= ones(n0+n1,n0)*diag(CX) ;
valF1t				= ones(n0+n1,n1)*diag([CY(Ip)-(t-floor(t)),CY(In)-(t-floor(t))+1]) ;
vsort				= [0,sort([valF0(1,:),valF1t(1,:)])] ;

Yt				= [ Y(Ip)+floor(t) ,  Y(In)+1+floor(t) ] ;
Yt				= [ Yt, Yt(1)+1] ; 

vk0 				= diag(.5*(vsort(2:n0+n1+1)+vsort(1:n0+n1)))*ones(n0+n1,n0) ;
vk1 				= diag(.5*(vsort(2:n0+n1+1)+vsort(1:n0+n1)))*ones(n0+n1,n1) ;

[vxk,nxk]			= max(vk0< valF0 ,[] , 2  ) ; 
[vyk,nyk]			= max([vk1,vk1(:,1)]<[valF1t,ones(n0+n1,1)] ,[] , 2) ;
xk				= reshape(X (nxk), n0+n1 , 1 ) ; 
yk				= reshape(Yt(nyk), n0+n1 , 1 ) ;
size(xk);
size(yk);
valC  				= [vsort(2:n0+n1+1)-vsort(1:n0+n1)]*cout(xk,yk,lambda) ;
%%
end
%------------------------------------------
function [valdcp,valdcm] = dC(t,X,Y,CX,CY,n0,n1,lambda)
%%
Ip				= CY-(t-floor(t))>=0 ;
In				= CY-(t-floor(t))< 0 ;

valF0				= ones(n1,n0)*diag(CX) ;
valF1t				= diag([CY(Ip)-(t-floor(t)),CY(In)-(t-floor(t))+1])*ones(n1,n0) ;
vsort				= [0,sort([valF0(1,:),[valF1t(:,1)]'])] ;
diff				= .5*(abs(vsort(2:n0+n1+1) - vsort(1:n0+n1))) ;
epsilon				= min(diff(diff>0)) ;

X				= [ X , X(1)+1] ;
Yt				= [ Y(Ip)+floor(t) , Y(In)+1+floor(t) ] ;
Yt				= [ Yt, Yt(1)+1] ;

[vxk,nxk]			= max( valF1t               <=   valF0                      , [] , 2) ;
[vxkm,nxkm]			= max([valF1t,valF1t(:,1)]  <= ([valF0-epsilon,ones(n1,1)]) , [] , 2) ;
xk				= X (nxk' ) ;
xkm				= X (nxkm') ;

valdcp				= sum(cout(xk ,Yt(2:n1+1),lambda) - cout(xk ,Yt(1:n1),lambda)) ;
valdcm				= sum(cout(xkm,Yt(2:n1+1),lambda) - cout(xkm,Yt(1:n1),lambda)) ;
%%
end
%------------------------------------------
function res=cout(x,y,lambda)
%%
res				= (abs(x-y)).^lambda ;
%%
end
%------------------------------------------
